// Endogenous variables 
var Util, 
Welf, 
instr1, 
instr2, 
Util1, 
Util2, 
c1c, 
c1cd, 
c1mc, 
c1y, 
c1g, 
c1rpcpd, 
c1pid, 
c1hp, 
c1gp, 
c1pstar, 
c1deltad, 
c1rn, 
c1rer, 
c1dcore, 
c1ngdp, 
c1pcore, 
c1dnxf, 
c2c, 
c2cd, 
c2mc, 
c2y, 
c2g, 
c2rpcpd, 
c2pid, 
c2hp, 
c2gp, 
c2pstar, 
c2deltad, 
c2rn, 
c2rer, 
c2dcore, 
c2ngdp, 
c2pcore, 
c2dnxf, 
Welfcon1,  
c1deltadlag,  
c1ngdplag,  
c1pcorelag,  
c1rerlag,  
c1rnlag,  
c1rpcpdlag,  
c1ylag,  
c2deltadlag,  
c2ngdplag,  
c2pcorelag,  
c2rerlag,  
c2rnlag,  
c2rpcpdlag,  
c2ylag;  
 
// Exogenous variables  
var c1shockgy, 
c1z, 
c1taupvar, 
c2shockgy, 
c2z, 
c2taupvar; 
 
varexo  c1shockgyerr 
c1zerr 
c2shockgyerr 
c2zerr 
c2taupvarerr 
c1taupvarerr 
c1monerr 
c2monerr; 
 
parameters   
omega_welf1, 
omega_welf2, 
nbeta,c1sigma, 
c1beta, 
c1rhoc,              
c1sharegy,           
c1rhogy,             
c1sigmagy,   
c1rhoz,            
c1sigmaz,        
c2sigma,             
c2beta,              
c2rhoc,              
c2sharegy,           
c2rhogy,             
c2sigmagy,  
c2rhoz,            
c2sigmaz,        
c2rhotaupvar,      
c2sigmataupvarerr, 
c1rhotaupvar,      
c1sigmataupvarerr, 
c2chi,               
c1chi,               
c2nup,            
c1nup,            
c2xip,               
c1xip,               
c1chi0, 
c1omegac, 
c1omegamc, 
c1relc2, 
c1pistar, 
c1taup, 
c2chi0, 
c2omegac, 
c2omegamc, 
c2pistar, 
c2taup, 
c1rnss, 
c2rnss, 
c1gamrn,                       
c1gamdpc,                         
c2gamrn,             
c2gamdpc, 
c2lambdaqss, 
c2rpcpdss, 
c1rerss, 
c1lambdaqss, 
c1rpcpdss; 
 
var lmult1,  lmult2,  lmult3,  lmult4,  lmult5,  lmult6,  lmult7,   
    lmult8,  lmult9,  lmult10,  lmult11,  lmult12,  lmult13,  lmult14,   
    lmult15,  lmult16,  lmult17,  lmult18,  lmult19,  lmult20,  lmult21,   
    lmult22,  lmult23,  lmult24,  lmult25,  lmult26,  lmult27,  lmult28,   
    lmult29,  lmult30,  lmult31,  lmult32,  lmult33,  lmult34,  lmult35,   
    lmult36,  lmult37,  lmult38,  lmult39,  lmult40,  lmult41,  lmult42,   
    lmult43,  lmult44,  lmult45,  lmult46,  lmult47,  lmult48,  lmult49,   
    lmult50,  lmult51,  Welf1,  Welf2; 
  
model; 
// Policymaker's First-Order Conditions 
lmult21*exp(c1c) - lmult23*((c1chi0*c1sigma*exp(c1c)*exp(c1rpcpd)*exp(c1y)*exp(c1c)^(c1sigma - 1)*(exp(-c1z)*exp(c1y))^c1chi*(c1nup + 1))/c1nup + (c1beta*c1sigma*c1xip*exp(-c1rpcpd(+1))*exp(c1c)*exp(c1hp(+1))*exp(c1rpcpd)*exp(c1c)^(c1sigma - 1))/(exp(c1c(+1))^c1sigma*(c1pistar/c1pid(+1))^(((c1chi + 1)*(c1nup + 1))/c1nup))) - (lmult17*exp(c1c))/exp(c1c)^c1sigma - (lmult50*exp(c1c))/exp(c1c)^c1sigma - (c1omegamc*c1rhoc*lmult20*exp(-c1mc)*exp(c1c)*(c1omegamc*exp(-c1mc)*exp(c1c))^(c1rhoc/(c1rhoc + 1) - 1))/(c1rhoc + 1) - c1lambdaqss*c1rerss*c1rpcpdss*c1sigma*lmult46*exp(-c1rer)*exp(c1c)*exp(c1c)^(c1sigma - 1) + (c1omegac*c1rhoc*lmult19*exp(-c1cd)*exp(c1c)*exp(c1rpcpd)*(c1omegac*exp(-c1cd)*exp(c1c))^(c1rhoc/(c1rhoc + 1) - 1))/(c1rhoc + 1) - (c1beta*c1sigma*lmult18*exp(-c1rpcpd(+1))*exp(c1c)*exp(c1rpcpd)*exp(c1c)^(c1sigma - 1))/(c1pid(+1)*exp(c1c(+1))^c1sigma) + (c1beta*c1sigma*lmult18(-1)*exp(-c1rpcpd)*exp(c1c)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(c1pid*nbeta*exp(c1c)^(c1sigma + 1)) - (c1beta*c1sigma*c1xip*lmult24*exp(-c1rpcpd(+1))*exp(c1c)*exp(c1gp(+1))*exp(c1rpcpd)*exp(c1c)^(c1sigma - 1)*(c1pistar/c1pid(+1))^(1 - (c1nup + 1)/c1nup))/exp(c1c(+1))^c1sigma + (c1beta*c1sigma*c1xip*lmult24(-1)*exp(-c1rpcpd)*exp(c1c)*exp(c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1pistar/c1pid)^(1 - (c1nup + 1)/c1nup))/(nbeta*exp(c1c)^(c1sigma + 1)) + (c1beta*c1sigma*c1xip*lmult23(-1)*exp(-c1rpcpd)*exp(c1c)*exp(c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(nbeta*exp(c1c)^(c1sigma + 1)*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup)); 
- lmult27*exp(c1cd) - c1omegac^(c1rhoc/(c1rhoc + 1))*lmult21*exp(c1cd)*exp(c1cd)^(1/(c1rhoc + 1) - 1)*(c1omegac^(c1rhoc/(c1rhoc + 1))*exp(c1cd)^(1/(c1rhoc + 1)) + c1omegamc^(c1rhoc/(c1rhoc + 1))*exp(c1mc)^(1/(c1rhoc + 1)))^c1rhoc - (c1omegac*c1rhoc*lmult19*exp(-c1cd)*exp(c1c)*exp(c1rpcpd)*(c1omegac*exp(-c1cd)*exp(c1c))^(c1rhoc/(c1rhoc + 1) - 1))/(c1rhoc + 1); 
lmult29 + lmult31 - (lmult49*exp(c2dnxf))/c2dcore + (c2dcore*lmult48*exp(c1dnxf))/c1dcore^2; 
lmult26*exp(c1deltad) - lmult3(+1)*nbeta + (c1chi0*lmult50*exp(c1deltad)*exp(c1y)^(c1chi + 1))/(exp(c1z)^c1chi*(c1chi + 1)); 
lmult3 - (c1xip*lmult26*exp(c1deltadlag))/(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup); 
-(c2dcore*lmult48*exp(c1dnxf))/c1dcore; 
lmult28*exp(c1g) - lmult27*exp(c1g); 
lmult24*exp(c1gp) + lmult22*exp(-c1gp)*exp(c1hp) - (c1beta*c1xip*lmult24(-1)*exp(-c1rpcpd)*exp(c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1pistar/c1pid)^(1 - (c1nup + 1)/c1nup))/(nbeta*exp(c1c)^c1sigma); 
lmult23*exp(c1hp) - lmult22*exp(-c1gp)*exp(c1hp) - (c1beta*c1xip*lmult23(-1)*exp(-c1rpcpd)*exp(c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(nbeta*exp(c1c)^c1sigma*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup)); 
(c1omegamc*c1rhoc*lmult20*exp(-c1mc)*exp(c1c)*(c1omegamc*exp(-c1mc)*exp(c1c))^(c1rhoc/(c1rhoc + 1) - 1))/(c1rhoc + 1) - c1omegamc^(c1rhoc/(c1rhoc + 1))*lmult21*exp(c1mc)*exp(c1mc)^(1/(c1rhoc + 1) - 1)*(c1omegac^(c1rhoc/(c1rhoc + 1))*exp(c1cd)^(1/(c1rhoc + 1)) + c1omegamc^(c1rhoc/(c1rhoc + 1))*exp(c1mc)^(1/(c1rhoc + 1)))^c1rhoc - c1relc2*lmult41*exp(c1mc); 
lmult30*exp(-c1ngdplag)*exp(c1ngdp) - lmult4(+1)*nbeta; 
lmult4 - lmult30*exp(-c1ngdplag)*exp(c1ngdp); 
- lmult5(+1)*nbeta - lmult31*exp(-c1pcorelag)*exp(c1pcore); 
lmult5 + lmult31*exp(-c1pcorelag)*exp(c1pcore); 
(c1pistar*c1xip*lmult25)/(c1nup*c1pid^2*(c1pistar/c1pid)^(1/c1nup + 1)) - lmult29*exp(-c1rpcpdlag)*exp(c1rpcpd) - lmult30*exp(-c1ylag)*exp(c1y) - lmult1 + (c1beta*lmult18(-1)*exp(-c1rpcpd)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(c1pid^2*nbeta*exp(c1c)^c1sigma) - (c1pistar*c1xip*lmult26*exp(c1deltadlag)*(c1chi + 1)*(c1nup + 1))/(c1nup*c1pid^2*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup + 1)) - (c1beta*c1pistar*c1xip*lmult24(-1)*exp(-c1rpcpd)*exp(c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*((c1nup + 1)/c1nup - 1))/(c1pid^2*nbeta*exp(c1c)^c1sigma*(c1pistar/c1pid)^((c1nup + 1)/c1nup)) - (c1beta*c1pistar*c1xip*lmult23(-1)*exp(-c1rpcpd)*exp(c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1chi + 1)*(c1nup + 1))/(c1nup*c1pid^2*nbeta*exp(c1c)^c1sigma*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup + 1)); 
lmult22*exp(c1pstar)*exp(c1pstar)^((c1chi*(c1nup + 1))/c1nup)*((c1chi*(c1nup + 1))/c1nup + 1) + (lmult25*exp(c1pstar)*(c1xip - 1))/(c1nup*exp(c1pstar)^(1/c1nup + 1)) - (lmult26*exp(c1pstar)*(c1chi + 1)*(c1nup + 1)*(c1xip - 1))/(c1nup*exp(c1pstar)^(((c1chi + 1)*(c1nup + 1))/c1nup + 1)); 
lmult47*exp(c1rer) - lmult6(+1)*nbeta - lmult34*exp(-c1rer)*exp(-c1rpcpd) + lmult20*exp(-c2rpcpd)*exp(c1rer) + lmult48*exp(-c1rerlag)*exp(c1rer) + c1lambdaqss*c1rerss*c1rpcpdss*lmult46*exp(-c1rer)*exp(c1c)^c1sigma; 
lmult6 - lmult48*exp(-c1rerlag)*exp(c1rer); 
- lmult7(+1)*nbeta - lmult18/(c1rn + 1)^2; 
lmult7; 
lmult19*exp(c1rpcpd)*(c1omegac*exp(-c1cd)*exp(c1c))^(c1rhoc/(c1rhoc + 1)) - lmult23*((c1chi0*exp(c1rpcpd)*exp(c1y)*exp(c1c)^c1sigma*(exp(-c1z)*exp(c1y))^c1chi*(c1nup + 1))/c1nup + (c1beta*c1xip*exp(-c1rpcpd(+1))*exp(c1hp(+1))*exp(c1rpcpd)*exp(c1c)^c1sigma)/(exp(c1c(+1))^c1sigma*(c1pistar/c1pid(+1))^(((c1chi + 1)*(c1nup + 1))/c1nup))) - lmult34*exp(-c1rer)*exp(-c1rpcpd) - lmult8(+1)*nbeta - c1pid*lmult29*exp(-c1rpcpdlag)*exp(c1rpcpd) - (c1beta*lmult18*exp(-c1rpcpd(+1))*exp(c1rpcpd)*exp(c1c)^c1sigma)/(c1pid(+1)*exp(c1c(+1))^c1sigma) + (c1beta*lmult18(-1)*exp(-c1rpcpd)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(c1pid*nbeta*exp(c1c)^c1sigma) - (c1beta*c1xip*lmult24*exp(-c1rpcpd(+1))*exp(c1gp(+1))*exp(c1rpcpd)*exp(c1c)^c1sigma*(c1pistar/c1pid(+1))^(1 - (c1nup + 1)/c1nup))/exp(c1c(+1))^c1sigma + (c1beta*c1xip*lmult23(-1)*exp(-c1rpcpd)*exp(c1hp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma)/(nbeta*exp(c1c)^c1sigma*(c1pistar/c1pid)^(((c1chi + 1)*(c1nup + 1))/c1nup)) + (c1beta*c1xip*lmult24(-1)*exp(-c1rpcpd)*exp(c1gp)*exp(c1rpcpd(-1))*exp(c1c(-1))^c1sigma*(c1pistar/c1pid)^(1 - (c1nup + 1)/c1nup))/(nbeta*exp(c1c)^c1sigma); 
lmult8 + c1pid*lmult29*exp(-c1rpcpdlag)*exp(c1rpcpd); 
lmult27*exp(c1y) - lmult23*((c1chi0*exp(c1rpcpd)*exp(c1y)*exp(c1c)^c1sigma*(exp(-c1z)*exp(c1y))^c1chi*(c1nup + 1))/c1nup + (c1chi*c1chi0*exp(2*c1y)*exp(-c1z)*exp(c1rpcpd)*exp(c1c)^c1sigma*(exp(-c1z)*exp(c1y))^(c1chi - 1)*(c1nup + 1))/c1nup) - lmult9(+1)*nbeta - c1pid*lmult30*exp(-c1ylag)*exp(c1y) - (lmult24*exp(c1y)*(c1taup*exp(c1taupvar) + 1))/c1nup - c1sharegy*lmult28*exp(c1shockgy)*exp(c1y) + (c1chi0*lmult50*exp(c1deltad)*exp(c1y)*exp(c1y)^c1chi)/exp(c1z)^c1chi; 
lmult9 + c1pid*lmult30*exp(-c1ylag)*exp(c1y); 
lmult35*exp(c2c) - lmult37*((c2chi0*c2sigma*exp(c2c)*exp(c2rpcpd)*exp(c2y)*exp(c2c)^(c2sigma - 1)*(exp(-c2z)*exp(c2y))^c2chi*(c2nup + 1))/c2nup + (c2beta*c2sigma*c2xip*exp(-c2rpcpd(+1))*exp(c2c)*exp(c2hp(+1))*exp(c2rpcpd)*exp(c2c)^(c2sigma - 1))/(exp(c2c(+1))^c2sigma*(c2pistar/c2pid(+1))^(((c2chi + 1)*(c2nup + 1))/c2nup))) - (lmult51*exp(c2c))/exp(c2c)^c2sigma + c2lambdaqss*c2rpcpdss*c2sigma*lmult46*exp(c2c)*exp(c2c)^(c2sigma - 1) - (c2omegamc*c2rhoc*lmult34*exp(-c2mc)*exp(c2c)*(c2omegamc*exp(-c2mc)*exp(c2c))^(c2rhoc/(c2rhoc + 1) - 1))/(c2rhoc + 1) + (c2omegac*c2rhoc*lmult33*exp(-c2cd)*exp(c2c)*exp(c2rpcpd)*(c2omegac*exp(-c2cd)*exp(c2c))^(c2rhoc/(c2rhoc + 1) - 1))/(c2rhoc + 1) - (c2beta*c2sigma*lmult32*exp(-c2rpcpd(+1))*exp(c2c)*exp(c2rpcpd)*exp(c2c)^(c2sigma - 1))/(c2pid(+1)*exp(c2c(+1))^c2sigma) + (c2beta*c2sigma*lmult32(-1)*exp(-c2rpcpd)*exp(c2c)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(c2pid*nbeta*exp(c2c)^(c2sigma + 1)) - (c2beta*c2sigma*c2xip*lmult38*exp(-c2rpcpd(+1))*exp(c2c)*exp(c2gp(+1))*exp(c2rpcpd)*exp(c2c)^(c2sigma - 1)*(c2pistar/c2pid(+1))^(1 - (c2nup + 1)/c2nup))/exp(c2c(+1))^c2sigma + (c2beta*c2sigma*c2xip*lmult38(-1)*exp(-c2rpcpd)*exp(c2c)*exp(c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2pistar/c2pid)^(1 - (c2nup + 1)/c2nup))/(nbeta*exp(c2c)^(c2sigma + 1)) + (c2beta*c2sigma*c2xip*lmult37(-1)*exp(-c2rpcpd)*exp(c2c)*exp(c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(nbeta*exp(c2c)^(c2sigma + 1)*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup)); 
- lmult41*exp(c2cd) - c2omegac^(c2rhoc/(c2rhoc + 1))*lmult35*exp(c2cd)*exp(c2cd)^(1/(c2rhoc + 1) - 1)*(c2omegac^(c2rhoc/(c2rhoc + 1))*exp(c2cd)^(1/(c2rhoc + 1)) + c2omegamc^(c2rhoc/(c2rhoc + 1))*exp(c2mc)^(1/(c2rhoc + 1)))^c2rhoc - (c2omegac*c2rhoc*lmult33*exp(-c2cd)*exp(c2c)*exp(c2rpcpd)*(c2omegac*exp(-c2cd)*exp(c2c))^(c2rhoc/(c2rhoc + 1) - 1))/(c2rhoc + 1); 
lmult43 + lmult45 - (lmult48*exp(c1dnxf))/c1dcore + (c1dcore*lmult49*exp(c2dnxf))/c2dcore^2; 
lmult40*exp(c2deltad) - lmult10(+1)*nbeta + (c2chi0*lmult51*exp(c2deltad)*exp(c2y)^(c2chi + 1))/(exp(c2z)^c2chi*(c2chi + 1)); 
lmult10 - (c2xip*lmult40*exp(c2deltadlag))/(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup); 
-(c1dcore*lmult49*exp(c2dnxf))/c2dcore; 
lmult42*exp(c2g) - lmult41*exp(c2g); 
lmult38*exp(c2gp) + lmult36*exp(-c2gp)*exp(c2hp) - (c2beta*c2xip*lmult38(-1)*exp(-c2rpcpd)*exp(c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2pistar/c2pid)^(1 - (c2nup + 1)/c2nup))/(nbeta*exp(c2c)^c2sigma); 
lmult37*exp(c2hp) - lmult36*exp(-c2gp)*exp(c2hp) - (c2beta*c2xip*lmult37(-1)*exp(-c2rpcpd)*exp(c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(nbeta*exp(c2c)^c2sigma*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup)); 
(c2omegamc*c2rhoc*lmult34*exp(-c2mc)*exp(c2c)*(c2omegamc*exp(-c2mc)*exp(c2c))^(c2rhoc/(c2rhoc + 1) - 1))/(c2rhoc + 1) - c2omegamc^(c2rhoc/(c2rhoc + 1))*lmult35*exp(c2mc)*exp(c2mc)^(1/(c2rhoc + 1) - 1)*(c2omegac^(c2rhoc/(c2rhoc + 1))*exp(c2cd)^(1/(c2rhoc + 1)) + c2omegamc^(c2rhoc/(c2rhoc + 1))*exp(c2mc)^(1/(c2rhoc + 1)))^c2rhoc - (lmult27*exp(c2mc))/c1relc2; 
lmult44*exp(-c2ngdplag)*exp(c2ngdp) - lmult11(+1)*nbeta; 
lmult11 - lmult44*exp(-c2ngdplag)*exp(c2ngdp); 
- lmult12(+1)*nbeta - lmult45*exp(-c2pcorelag)*exp(c2pcore); 
lmult12 + lmult45*exp(-c2pcorelag)*exp(c2pcore); 
(c2pistar*c2xip*lmult39)/(c2nup*c2pid^2*(c2pistar/c2pid)^(1/c2nup + 1)) - lmult43*exp(-c2rpcpdlag)*exp(c2rpcpd) - lmult44*exp(-c2ylag)*exp(c2y) - lmult2 + (c2beta*lmult32(-1)*exp(-c2rpcpd)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(c2pid^2*nbeta*exp(c2c)^c2sigma) - (c2pistar*c2xip*lmult40*exp(c2deltadlag)*(c2chi + 1)*(c2nup + 1))/(c2nup*c2pid^2*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup + 1)) - (c2beta*c2pistar*c2xip*lmult38(-1)*exp(-c2rpcpd)*exp(c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*((c2nup + 1)/c2nup - 1))/(c2pid^2*nbeta*exp(c2c)^c2sigma*(c2pistar/c2pid)^((c2nup + 1)/c2nup)) - (c2beta*c2pistar*c2xip*lmult37(-1)*exp(-c2rpcpd)*exp(c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2chi + 1)*(c2nup + 1))/(c2nup*c2pid^2*nbeta*exp(c2c)^c2sigma*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup + 1)); 
lmult36*exp(c2pstar)*exp(c2pstar)^((c2chi*(c2nup + 1))/c2nup)*((c2chi*(c2nup + 1))/c2nup + 1) + (lmult39*exp(c2pstar)*(c2xip - 1))/(c2nup*exp(c2pstar)^(1/c2nup + 1)) - (lmult40*exp(c2pstar)*(c2chi + 1)*(c2nup + 1)*(c2xip - 1))/(c2nup*exp(c2pstar)^(((c2chi + 1)*(c2nup + 1))/c2nup + 1)); 
lmult47*exp(-c2rer) - lmult13(+1)*nbeta + lmult49*exp(-c2rerlag)*exp(c2rer); 
lmult13 - lmult49*exp(-c2rerlag)*exp(c2rer); 
- lmult14(+1)*nbeta - lmult32/(c2rn + 1)^2; 
lmult14; 
lmult33*exp(c2rpcpd)*(c2omegac*exp(-c2cd)*exp(c2c))^(c2rhoc/(c2rhoc + 1)) - lmult37*((c2chi0*exp(c2rpcpd)*exp(c2y)*exp(c2c)^c2sigma*(exp(-c2z)*exp(c2y))^c2chi*(c2nup + 1))/c2nup + (c2beta*c2xip*exp(-c2rpcpd(+1))*exp(c2hp(+1))*exp(c2rpcpd)*exp(c2c)^c2sigma)/(exp(c2c(+1))^c2sigma*(c2pistar/c2pid(+1))^(((c2chi + 1)*(c2nup + 1))/c2nup))) - lmult15(+1)*nbeta - lmult20*exp(-c2rpcpd)*exp(c1rer) - c2pid*lmult43*exp(-c2rpcpdlag)*exp(c2rpcpd) - (c2beta*lmult32*exp(-c2rpcpd(+1))*exp(c2rpcpd)*exp(c2c)^c2sigma)/(c2pid(+1)*exp(c2c(+1))^c2sigma) + (c2beta*lmult32(-1)*exp(-c2rpcpd)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(c2pid*nbeta*exp(c2c)^c2sigma) - (c2beta*c2xip*lmult38*exp(-c2rpcpd(+1))*exp(c2gp(+1))*exp(c2rpcpd)*exp(c2c)^c2sigma*(c2pistar/c2pid(+1))^(1 - (c2nup + 1)/c2nup))/exp(c2c(+1))^c2sigma + (c2beta*c2xip*lmult37(-1)*exp(-c2rpcpd)*exp(c2hp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma)/(nbeta*exp(c2c)^c2sigma*(c2pistar/c2pid)^(((c2chi + 1)*(c2nup + 1))/c2nup)) + (c2beta*c2xip*lmult38(-1)*exp(-c2rpcpd)*exp(c2gp)*exp(c2rpcpd(-1))*exp(c2c(-1))^c2sigma*(c2pistar/c2pid)^(1 - (c2nup + 1)/c2nup))/(nbeta*exp(c2c)^c2sigma); 
lmult15 + c2pid*lmult43*exp(-c2rpcpdlag)*exp(c2rpcpd); 
lmult41*exp(c2y) - lmult37*((c2chi0*exp(c2rpcpd)*exp(c2y)*exp(c2c)^c2sigma*(exp(-c2z)*exp(c2y))^c2chi*(c2nup + 1))/c2nup + (c2chi*c2chi0*exp(2*c2y)*exp(-c2z)*exp(c2rpcpd)*exp(c2c)^c2sigma*(exp(-c2z)*exp(c2y))^(c2chi - 1)*(c2nup + 1))/c2nup) - lmult16(+1)*nbeta - c2pid*lmult44*exp(-c2ylag)*exp(c2y) - (lmult38*exp(c2y)*(c2taup*exp(c2taupvar) + 1))/c2nup - c2sharegy*lmult42*exp(c2shockgy)*exp(c2y) + (c2chi0*lmult51*exp(c2deltad)*exp(c2y)*exp(c2y)^c2chi)/exp(c2z)^c2chi; 
lmult16 + c2pid*lmult44*exp(-c2ylag)*exp(c2y); 
lmult1; 
lmult2; 
lmult50 + omega_welf1; 
lmult51 + omega_welf2; 
lmult17 - (c1beta*lmult17(-1))/nbeta; 
 
////////////////////////////////// 
// Utility and Welfare bloc 
////////////////////////////////// 
 
// Utility, aggregate  
Util = omega_welf1*Util1+omega_welf2*Util2; 
 
// Welfare, aggregate  
Welf = Util + nbeta*Welf(1); 
 
//// Welfare, agent 1 
Welf1 = Util1 + nbeta*Welf1(1); 
 
//// Welfare, agent 2 
Welf2 = Util2+ nbeta*Welf2(1); 
 
// Policy instrument, agent 1 
instr1 = c1pid; 
 
// Policy instrument, agent 2 
instr2 = c2pid; 
 
 c1deltadlag =c1deltad(-1);  
c1ngdplag =c1ngdp(-1);  
c1pcorelag =c1pcore(-1);  
c1rerlag =c1rer(-1);  
c1rnlag =c1rn(-1);  
c1rpcpdlag =c1rpcpd(-1);  
c1ylag =c1y(-1);  
c2deltadlag =c2deltad(-1);  
c2ngdplag =c2ngdp(-1);  
c2pcorelag =c2pcore(-1);  
c2rerlag =c2rer(-1);  
c2rnlag =c2rn(-1);  
c2rpcpdlag =c2rpcpd(-1);  
c2ylag =c2y(-1);  
  
////////////////////////////////// 
// Monetary policy bloc 
////////////////////////////////// 
 
 
 
// Welfcon1 
Welfcon1 = (exp(c1c))^(1-c1sigma)/(1-c1sigma) + c1beta*Welfcon1(+1); 
 
 
////////////////////////////////// 
// Home country bloc  
////////////////////////////////// 
 
// definition of nominal interest rate  
1/(1+(c1rn)) = c1beta*(((exp(c1c(+1)))^(-c1sigma)/exp(c1rpcpd(+1))))/(((exp(c1c))^(-c1sigma)/exp(c1rpcpd)))/c1pid(+1); 
 
// fonc domestic consumption good 
exp(c1rpcpd)*(c1omegac*exp(c1c)/exp(c1cd))^(c1rhoc/(1+c1rhoc)) = 1; 
 
// fonc imported good 
(exp(c1rer))/(exp(c2rpcpd))= (c1omegamc*exp(c1c)/exp(c1mc))^(c1rhoc/(1+c1rhoc)); 
 
// final consumption  
exp(c1c) = ((c1omegac)^(c1rhoc/(1+c1rhoc))*exp(c1cd)^(1/(1+c1rhoc))+(c1omegamc)^(c1rhoc/(1+c1rhoc))*(exp(c1mc))^(1/(1+c1rhoc)))^(1+c1rhoc); 
 
// definition of pstar 
(exp(c1pstar))^(1+(1+c1nup)/(c1nup)*c1chi) = (exp(c1hp))/(exp(c1gp)); 
 
// definition of hp 
(exp(c1hp)) = (1+(c1nup))/(c1nup) 
*c1chi0*(exp(c1y)/exp(c1z))^(c1chi)/((exp(c1c))^(-c1sigma)/exp(c1rpcpd))*exp(c1y) 
+ c1xip*c1beta*(((exp(c1c(+1)))^(-c1sigma)/exp(c1rpcpd(+1))))/(((exp(c1c))^(-c1sigma)/exp(c1rpcpd)))*((c1pistar)/(c1pid(+1)))^(-(1 
+(c1nup))/(c1nup)*(1+c1chi))*(exp(c1hp(+1))); 
 
// definition of gp 
(exp(c1gp)) = (1+c1taup*exp(c1taupvar))/(c1nup)*(exp(c1y))+c1xip*c1beta*(((exp(c1c(+1)))^(-c1sigma)/exp(c1rpcpd(+1))))/(((exp(c1c))^(-c1sigma)/exp(c1rpcpd)))*((c1pistar)/(c1pid(+1)))^(1 
-(1+(c1nup))/(c1nup))*(exp(c1gp(+1))); 
 
// price evolution 
(1-c1xip)*((exp(c1pstar)))^(-1/(c1nup))+c1xip*((c1pistar)/(c1pid))^(-1/(c1nup)) = 1; 
 
// evolution of price dispersion 
(exp(c1deltad)) = (1-c1xip)*((exp(c1pstar)))^(-(1+(c1nup))/(c1nup)*(1+c1chi)) 
+c1xip*((c1pistar)/(c1pid))^(-(1+(c1nup))/(c1nup)*(1+c1chi))*(exp(c1deltadlag)); 
 
// resource constraint goods 
exp(c1y) = exp(c1cd)+exp(c1g)+1/c1relc2*(exp(c2mc)); 
 
// government spending 
exp(c1g) = c1sharegy*exp(c1y)*exp(c1shockgy); 
 
// core inflation 
c1dcore = exp(c1rpcpd)/exp(c1rpcpdlag)*c1pid; 
 
// nominal gdp 
exp(c1ngdp)/exp(c1ngdplag) = c1pid*exp(c1y)/exp(c1ylag);  
 
// consumer price level 
c1dcore = exp(c1pcore)/exp(c1pcorelag); 
 
 
////////////////////////////////// 
// Foreign country bloc  
////////////////////////////////// 
 
// definition of nominal interest rate 
1/(1+(c2rn)) = c2beta*(((exp(c2c(+1)))^(-c2sigma)/exp(c2rpcpd(+1))))/(((exp(c2c))^(-c2sigma)/exp(c2rpcpd)))/c2pid(+1); 
 
// fonc domestic consumption good 
(exp(c2rpcpd))*(c2omegac*(exp(c2c))/(exp(c2cd)))^(c2rhoc/(1+c2rhoc)) = 1; 
 
// fonc imported good 
1/(exp(c1rer))/(exp(c1rpcpd)) = (c2omegamc*(exp(c2c))/(exp(c2mc)))^(c2rhoc/(1+c2rhoc)); 
 
// final consumption 
(exp(c2c)) = ((c2omegac)^(c2rhoc/(1+c2rhoc))*(exp(c2cd))^(1/(1+c2rhoc))+(c2omegamc)^(c2rhoc/(1+c2rhoc))*((exp(c2mc)))^(1/(1+c2rhoc)))^(1+c2rhoc); 
 
// definition of pstar 
(exp(c2pstar))^(1+(1+c2nup)/(c2nup)*c2chi) = (exp(c2hp))/(exp(c2gp)); 
 
// definition of hp 
(exp(c2hp)) = (1+(c2nup))/(c2nup) 
*c2chi0*(exp(c2y)/exp(c2z))^c2chi/((exp(c2c))^(-c2sigma)/exp(c2rpcpd))*exp(c2y) 
+ c2xip*c2beta*(((exp(c2c(+1)))^(-c2sigma)/exp(c2rpcpd(+1))))/(((exp(c2c))^(-c2sigma)/exp(c2rpcpd)))*((c2pistar)/(c2pid(+1)))^(-(1 
+(c2nup))/(c2nup)*(1+c2chi))*(exp(c2hp(+1))); 
 
// definition of gp 
(exp(c2gp)) = (1+c2taup*exp(c2taupvar))/(c2nup)*(exp(c2y))+c2xip*c2beta*(((exp(c2c(+1)))^(-c2sigma)/exp(c2rpcpd(+1))))/(((exp(c2c))^(-c2sigma)/exp(c2rpcpd)))*((c2pistar)/(c2pid(+1)))^(1 
-(1+(c2nup))/(c2nup))*(exp(c2gp(+1))); 
 
// price evolution 
(1-c2xip)*((exp(c2pstar)))^(-1/(c2nup))+c2xip*((c2pistar)/(c2pid))^(-1/(c2nup)) = 1; 
 
// evolution of price dispersion 
(exp(c2deltad)) = (1-c2xip)*((exp(c2pstar)))^(-(1+(c2nup))/(c2nup)*(1+c2chi)) 
+c2xip*((c2pistar)/(c2pid))^(-(1+(c2nup))/(c2nup)*(1+c2chi))*(exp(c2deltadlag)); 
 
// resource constraint goods 
(exp(c2y)) = (exp(c2cd))+(exp(c2g))+(c1relc2*(exp(c1mc))); 
 
// government spending 
(exp(c2g)) = c2sharegy*(exp(c2y))*(exp(c2shockgy)); 
 
// core inflation 
c2dcore = exp(c2rpcpd)/exp(c2rpcpdlag)*c2pid; 
 
// nominal gdp 
exp(c2ngdp)/exp(c2ngdplag) = c2pid*exp(c2y)/exp(c2ylag);  
 
// consumer price level 
c2dcore = exp(c2pcore)/exp(c2pcorelag); 
 
//////////////////////// 
// international links 
//////////////////////// 
 
// risk sharing  
c2lambdaqss/((exp(c2c))^(-c2sigma))*c2rpcpdss = c1rerss/(exp(c1rer))*c1lambdaqss/((exp(c1c))^(-c1sigma))*c1rpcpdss; 
 
// real exchange rate 
exp(c1rer) = 1/exp(c2rer); 
 
// nominal exchange rate 
exp(c1rer)/exp(c1rerlag) = exp(c1dnxf)*c2dcore/c1dcore; 
 
// nominal exchange rate 
exp(c2rer)/exp(c2rerlag) = exp(c2dnxf)*c1dcore/c2dcore; 
 
// Utility, country 1 
Util1 = (exp(c1c))^(1-c1sigma)/(1-c1sigma)-c1chi0*(exp(c1z))^(-c1chi)*(exp(c1y))^(1+c1chi)/(1+c1chi)*exp(c1deltad); 
 
// Utility, country 2 
Util2 = (exp(c2c))^(1-c2sigma)/(1-c2sigma)-c2chi0*(exp(c2z))^(-c2chi)*(exp(c2y))^(1+c2chi)/(1+c2chi)*exp(c2deltad); 
 
 
///////////////////////// 
// exogenous variables 
///////////////////////// 
 
c1shockgy = c1rhogy*c1shockgy(-1) + c1sigmagy*c1shockgyerr; 
 
c1z = c1rhoz*c1z(-1) + c1sigmaz*c1zerr; 
 
c1taupvar = c1rhotaupvar*c1taupvar(-1)+c1sigmataupvarerr*c1taupvarerr; 
 
c2shockgy = c2rhogy*c2shockgy(-1) + c2sigmagy*c2shockgyerr; 
 
c2z = c2rhoz*c2z(-1) + c2sigmaz*c2zerr; 
 
c2taupvar = c2rhotaupvar*c2taupvar(-1)+c2sigmataupvarerr*c2taupvarerr; 
 
end; 
 
 
shocks; 
var c1shockgyerr = 0;  
var c1zerr = 1;  
var c2shockgyerr = 0;  
var c2zerr = 1; 
var c2taupvarerr = 1; 
var c1taupvarerr = 1; 
end; 

 
steady; 
 
check; 
 
stoch_simul(order=2,nocorr,noprint,irf=0); 
