// Endogenous variables 
var Welf1, 
Welf2, 
instr1, 
instr2,  
 
k, y, w, rs, lambdac, l, r, s, n, v, eta, in, ig, q, c, gc, spread,  
l2n, rmon, infl, phi, dphidp, dphidlp, sigma, n2y, Util1, Util2, bt,  
btlag,  
clag,  
etalag,  
iglag,  
infllag,  
klag,  
llag,  
rmonlag,  
qlag,  
rlag,  
nlag,  
slag,  
vlag,  
ylag,
Util_nobias, Welf_nobias;  
 
// Exogenous variables       
var  
z, lambda, betavar, cpref, markup; 
 
varexo  
errz, errmon, errlambda, errbt, errbetavar, errcpref, errmarkup; 
 
 
parameters  
omega_welf1, 
omega_welf2, 
nbeta, 
alphap, gammap, chi0p, chip, betap, deltap, 
psip,  omegagyp, lambdap, thetap, baromegap,  
s2n, phip, spreadp, nup, taup, indexp,  
mu_mpr, mu_cb, xip, blife,  
rs_rslp, rs_inflp, rs_yp, bt_btlp, bt_sp, 
rhozp, sigmazp, rholambdap, sigmalambdap, 
rhobtp, sigmabtp, rhobetavarp, sigmabetavarp, 
rhocprefp, sigmacprefp, 
l_ss, q_ss, r_ss, y_ss, w_ss, k_ss, s_ss, n_ss,  
in_ss, ig_ss, gc_ss, infl_ss, sigmamarkup, rhomarkup; 
 
var c1lmult1,  c1lmult2,  c1lmult3,  c1lmult4,  c1lmult5,  c1lmult6,   
    c1lmult7,  c1lmult8,  c1lmult9,  c1lmult10,  c1lmult11,  c1lmult12,   
    c1lmult13,  c1lmult14,  c1lmult15,  c1lmult16,  c1lmult17,  c1lmult18,   
    c1lmult19,  c1lmult20,  c1lmult21,  c1lmult22,  c1lmult23,  c1lmult24,   
    c1lmult25,  c1lmult26,  c1lmult27,  c1lmult28,  c1lmult29,  c1lmult30,   
    c1lmult31,  c1lmult32,  c1lmult33,  c1lmult34,  c1lmult35,  c1lmult36,   
    c1lmult37,  c1lmult38,  c1lmult39,  c1lmult40,  c2lmult1,  c2lmult2,   
    c2lmult3,  c2lmult4,  c2lmult5,  c2lmult6,  c2lmult7,  c2lmult8,   
    c2lmult9,  c2lmult10,  c2lmult11,  c2lmult12,  c2lmult13,  c2lmult14,   
    c2lmult15,  c2lmult16,  c2lmult17,  c2lmult18,  c2lmult19,  c2lmult20,   
    c2lmult21,  c2lmult22,  c2lmult23,  c2lmult24,  c2lmult25,  c2lmult26,   
    c2lmult27,  c2lmult28,  c2lmult29,  c2lmult30,  c2lmult31,  c2lmult32,   
    c2lmult33,  c2lmult34,  c2lmult35,  c2lmult36,  c2lmult37,  c2lmult38,   
    c2lmult39,  c2lmult40,  Util,  Welf; 
  
model; 
 
////////////////////////////////// 
// Utility and Welfare bloc 
////////////////////////////////// 
 
//// Utility, aggregate  
Util = omega_welf1*Util1+omega_welf2*Util2; 
 
//// Welfare, aggregate  
Welf = Util + nbeta*Welf(1); 
 
// Welfare, agent 1 
Welf1 = Util1 + nbeta*Welf1(1); 
 
// Welfare, agent 2 
Welf2 = Util2+ nbeta*Welf2(1); 
 
// Policy instrument, agent 1 
instr1 = infl; 
 
// Policy instrument, agent 2 
instr2 = bt; 
 
 btlag =bt(-1);  
clag =c(-1);  
etalag =eta(-1);  
iglag =ig(-1);  
infllag =infl(-1);  
klag =k(-1);  
llag =l(-1);  
rmonlag =rmon(-1);  
qlag =q(-1);  
rlag =r(-1);  
nlag =n(-1);  
slag =s(-1);  
vlag =v(-1);  
ylag =y(-1);  
  
///////////////// 
// Policy bloc 
///////////////// 
 
// Policymaker's First-Order Conditions for Country 1 
(c1lmult20*eta*n)/(lambda - v) - c1lmult3(+1)*nbeta - c1lmult2 + (betap*c1lmult23(-1)*eta*lambdac*thetap*(r(-1) - (eta(-1)*(r(-1) - rs))/(lambdap - v(-1)) + 1))/(lambdac(-1)*nbeta) + (betap*c1lmult22(-1)*eta*lambdac*thetap*v*(lambdap - v(-1))*(r(-1) - (eta(-1)*(r(-1) - rs))/(lambdap - v(-1)) + 1))/(eta(-1)*lambdac(-1)*nbeta*(lambdap - v)); 
c1lmult3 + c1lmult21*nlag*thetap*(r(-1) - (etalag*(r(-1) - rs))/(lambda(-1) - vlag) + 1); 
c1lmult17*(1/(c + cpref - clag*gammap)^2 + (betavar*gammap^2)/(c(+1) + cpref(+1) - c*gammap)^2) - c1lmult35 - c1lmult4(+1)*nbeta + 1/(c + cpref - clag*gammap) - (betavar(-1)*c1lmult17(-1)*gammap)/(nbeta*(c + cpref - c(-1)*gammap)^2); 
c1lmult4 - gammap/(c + cpref - clag*gammap) - (c1lmult17*gammap)/(c + cpref - clag*gammap)^2; 
c1lmult31 + (c1lmult28(-1)*y)/(nbeta*(rmon(-1) + 1)); 
c1lmult30 + c1lmult28*y; 
(c1lmult20*n*(bt - 1))/(lambda - v) - c1lmult22*((betap*eta(+1)*lambdac(+1)*thetap*v(+1)*(r - rs(+1))*(bt(+1) - 1))/(eta*lambdac*(lambdap - v(+1))) + (betap*eta(+1)*lambdac(+1)*thetap*v(+1)*(lambdap - v)*(bt(+1) - 1)*(r - (eta*(r - rs(+1)))/(lambdap - v) + 1))/(eta^2*lambdac*(lambdap - v(+1)))) - c1lmult23*((betap*eta(+1)*lambdac(+1)*thetap*(r - rs(+1))*(bt(+1) - 1))/(lambdac*(lambdap - v)) - 1) - c1lmult38/(lambdap - v) - c1lmult5(+1)*nbeta + (betap*c1lmult23(-1)*lambdac*thetap*(bt - 1)*(r(-1) - (eta(-1)*(r(-1) - rs))/(lambdap - v(-1)) + 1))/(lambdac(-1)*nbeta) + (betap*c1lmult22(-1)*lambdac*thetap*v*(lambdap - v(-1))*(bt - 1)*(r(-1) - (eta(-1)*(r(-1) - rs))/(lambdap - v(-1)) + 1))/(eta(-1)*lambdac(-1)*nbeta*(lambdap - v)); 
c1lmult5 - (c1lmult21*nlag*thetap*(r(-1) - rs)*(btlag - 1))/(lambda(-1) - vlag); 
c1lmult36 - c1lmult35; 
c1lmult33*((psip*(ig/iglag - 1)^2)/2 + (ig*psip*(ig/iglag - 1))/iglag - 1) - c1lmult6(+1)*nbeta - c1lmult35 - c1lmult34*((ig*psip*q)/ig(-1)^2 + (2*psip*q*(ig/ig(-1) - 1))/ig(-1) + (betavar*ig(+1)^3*lambdac(+1)*psip*q(+1))/(ig^4*lambdac) + (2*betavar*ig(+1)^2*lambdac(+1)*psip*q(+1)*(ig(+1)/ig - 1))/(ig^3*lambdac)) + (c1lmult34(-1)*((betavar(-1)*ig^2*lambdac*psip*q)/(ig(-1)^3*lambdac(-1)) + (2*betavar(-1)*ig*lambdac*psip*q*(ig/ig(-1) - 1))/(ig(-1)^2*lambdac(-1))))/nbeta + c1lmult34(+1)*nbeta*((ig(+1)^2*psip*q(+1))/ig^3 + (2*ig(+1)*psip*q(+1)*(ig(+1)/ig - 1))/ig^2); 
c1lmult6 - (c1lmult33*ig^2*psip*(ig/iglag - 1))/iglag^2; 
c1lmult33 - c1lmult32; 
c1lmult31*((infl^2*phip)/(indexp*infl(-1) - infl_ss*(indexp - 1))^2 + (2*infl*phip*(infl/(indexp*infl(-1) - infl_ss*(indexp - 1)) - 1))/(indexp*infl(-1) - infl_ss*(indexp - 1))) - c1lmult7(+1)*nbeta - c1lmult1 - mu_cb*(2*infl - 2*infl_ss) - c1lmult30*((infl*phip)/(indexp*infl(-1) - infl_ss*(indexp - 1))^2 + (phip*(infl/(indexp*infl(-1) - infl_ss*(indexp - 1)) - 1))/(indexp*infl(-1) - infl_ss*(indexp - 1))) - c1lmult31(+1)*nbeta*((indexp*infl(+1)^3*phip)/(indexp*infl - infl_ss*(indexp - 1))^3 + (indexp*infl(+1)^2*phip*(infl(+1)/(indexp*infl - infl_ss*(indexp - 1)) - 1))/(indexp*infl - infl_ss*(indexp - 1))^2) + c1lmult30(+1)*nbeta*((indexp*infl(+1)^2*phip)/(indexp*infl - infl_ss*(indexp - 1))^3 + (indexp*infl(+1)*phip*(infl(+1)/(indexp*infl - infl_ss*(indexp - 1)) - 1))/(indexp*infl - infl_ss*(indexp - 1))^2) - (c1lmult29*phip*(infl/(indexp*infllag - infl_ss*(indexp - 1)) - 1))/(indexp*infllag - infl_ss*(indexp - 1)) - (c1lmult39(-1)*lambdac)/(infl^2*lambdac(-1)*nbeta); 
c1lmult7 + (c1lmult29*indexp*infl*phip*(infl/(indexp*infllag - infl_ss*(indexp - 1)) - 1))/(indexp*infllag - infl_ss*(indexp - 1))^2; 
c1lmult1; 
c1lmult24 + c1lmult32 - c1lmult8(+1)*nbeta; 
c1lmult8 + c1lmult32*(deltap - 1) - alphap*c1lmult25*klag^(alphap - 1)*l^(1 - alphap)*exp(z) + (alphap*c1lmult27*sigma*y)/(klag^2*q(-1)); 
c1lmult26 - c1lmult9(+1)*nbeta - chi0p*l^chip + c1lmult18*chip*chi0p*l^(chip - 1) + (c1lmult25*klag^alphap*exp(z)*(alphap - 1))/l^alphap; 
c1lmult38; 
c1lmult17 - c1lmult18*w + c1lmult22*((betap*lambdac(+1)*(r - rs(+1))*(thetap - 1))/lambdac^2 - (betap*eta(+1)*lambdac(+1)*thetap*v(+1)*(lambdap - v)*(bt(+1) - 1)*(r - (eta*(r - rs(+1)))/(lambdap - v) + 1))/(eta*lambdac^2*(lambdap - v(+1)))) - (c1lmult22(-1)*((betap*(r(-1) - rs)*(thetap - 1))/lambdac(-1) - (betap*eta*thetap*v*(lambdap - v(-1))*(bt - 1)*(r(-1) - (eta(-1)*(r(-1) - rs))/(lambdap - v(-1)) + 1))/(eta(-1)*lambdac(-1)*(lambdap - v))))/nbeta + c1lmult19(-1)/(lambdac(-1)*nbeta) - (c1lmult19*lambdac(+1))/lambdac^2 + c1lmult39(-1)/(infl*lambdac(-1)*nbeta) - (c1lmult39*lambdac(+1))/(infl(+1)*lambdac^2) - (betap*c1lmult23*eta(+1)*lambdac(+1)*thetap*(bt(+1) - 1)*(r - (eta*(r - rs(+1)))/(lambdap - v) + 1))/lambdac^2 + (betap*c1lmult23(-1)*eta*thetap*(bt - 1)*(r(-1) - (eta(-1)*(r(-1) - rs))/(lambdap - v(-1)) + 1))/(lambdac(-1)*nbeta) + (betavar(-1)*c1lmult34(-1)*ig^2*psip*q*(ig/ig(-1) - 1))/(ig(-1)^2*lambdac(-1)*nbeta) - (betavar*c1lmult34*ig(+1)^2*lambdac(+1)*psip*q(+1)*(ig(+1)/ig - 1))/(ig^2*lambdac^2); 
c1lmult9; 
c1lmult21 - c1lmult13(+1)*nbeta - c1lmult40/y + (c1lmult20*eta*(bt - 1))/(lambda - v); 
c1lmult40; 
c1lmult13 + c1lmult21*thetap*(btlag - 1)*(r(-1) - (etalag*(r(-1) - rs))/(lambda(-1) - vlag) + 1); 
c1lmult29 - c1lmult35*y; 
c1lmult20*s - c1lmult34*((psip*(ig/ig(-1) - 1)^2)/2 + (ig*psip*(ig/ig(-1) - 1))/ig(-1) - 1) - c1lmult11(+1)*nbeta - c1lmult27(+1)*nbeta*((q(+1)*(deltap - 1))/q^2 - (alphap*sigma(+1)*y(+1))/(klag(+1)*q^2)) + (c1lmult27*(deltap - 1))/q(-1) - baromegap*c1lmult21*slag + (betavar(-1)*c1lmult34(-1)*ig^2*lambdac*psip*(ig/ig(-1) - 1))/(ig(-1)^2*lambdac(-1)*nbeta); 
c1lmult11; 
c1lmult19/(betavar*(r + 1)^2) - c1lmult22*((betap*lambdac(+1)*(thetap - 1))/lambdac + (betap*eta(+1)*lambdac(+1)*thetap*v(+1)*(eta/(lambdap - v) - 1)*(lambdap - v)*(bt(+1) - 1))/(eta*lambdac*(lambdap - v(+1)))) - c1lmult12(+1)*nbeta - c1lmult21(+1)*nbeta*nlag(+1)*thetap*(etalag(+1)/(lambda - vlag(+1)) - 1)*(btlag(+1) - 1) - (betap*c1lmult23*eta(+1)*lambdac(+1)*thetap*(eta/(lambdap - v) - 1)*(bt(+1) - 1))/lambdac; 
c1lmult12 + c1lmult37; 
c1lmult39/(betavar*(rmon + 1)^2) - c1lmult10(+1)*nbeta - (c1lmult28*dphidlp(+1)*y(+1))/(rmon + 1)^2; 
c1lmult10; 
c1lmult27 - c1lmult37 + (c1lmult22(-1)*((betap*lambdac*(thetap - 1))/lambdac(-1) + (betap*eta*lambdac*thetap*v*(bt - 1))/(lambdac(-1)*(lambdap - v))))/nbeta + (c1lmult21*etalag*nlag*thetap*(btlag - 1))/(lambda(-1) - vlag) + (betap*c1lmult23(-1)*eta*eta(-1)*lambdac*thetap*(bt - 1))/(lambdac(-1)*nbeta*(lambdap - v(-1))); 
c1lmult20*q - c1lmult14(+1)*nbeta - c1lmult24; 
(c1lmult26*y*(alphap - 1))/w - (c1lmult28*y*(nup + 1))/nup - (alphap*c1lmult27*y)/(klag*q(-1)); 
c1lmult14 - baromegap*c1lmult21*q; 
c1lmult37; 
(c1lmult22(-1)*((betap*eta*lambdac*thetap*(lambdap - v(-1))*(bt - 1)*(r(-1) - (eta(-1)*(r(-1) - rs))/(lambdap - v(-1)) + 1))/(eta(-1)*lambdac(-1)*(lambdap - v)) + (betap*eta*lambdac*thetap*v*(lambdap - v(-1))*(bt - 1)*(r(-1) - (eta(-1)*(r(-1) - rs))/(lambdap - v(-1)) + 1))/(eta(-1)*lambdac(-1)*(lambdap - v)^2)))/nbeta - c1lmult22*((betap*eta(+1)*lambdac(+1)*thetap*v(+1)*(bt(+1) - 1)*(r - (eta*(r - rs(+1)))/(lambdap - v) + 1))/(eta*lambdac*(lambdap - v(+1))) + (betap*eta(+1)*lambdac(+1)*thetap*v(+1)*(r - rs(+1))*(bt(+1) - 1))/(lambdac*(lambdap - v)*(lambdap - v(+1))) - 1) - (c1lmult38*eta)/(lambdap - v)^2 - c1lmult15(+1)*nbeta + (c1lmult20*eta*n*(bt - 1))/(lambda - v)^2 - (betap*c1lmult23*eta*eta(+1)*lambdac(+1)*thetap*(r - rs(+1))*(bt(+1) - 1))/(lambdac*(lambdap - v)^2); 
c1lmult15 - (c1lmult21*etalag*nlag*thetap*(r(-1) - rs)*(btlag - 1))/(lambda(-1) - vlag)^2; 
- c1lmult18*lambdac - (c1lmult26*sigma*y*(alphap - 1))/w^2; 
c1lmult25 - c1lmult16(+1)*nbeta - c1lmult36*omegagyp + c1lmult28*(dphidp + (markup + taup + 1)/nup - (sigma*(nup + 1))/nup) - c1lmult35*(phi - 1) + (c1lmult40*n)/y^2 + (c1lmult28(-1)*dphidlp)/(nbeta*(rmon(-1) + 1)) + (c1lmult26*sigma*(alphap - 1))/w - (alphap*c1lmult27*sigma)/(klag*q(-1)); 
c1lmult16; 
 
// Policymaker's First-Order Conditions for Country 2 
(c2lmult20*eta*n)/(lambda - v) - c2lmult3(+1)*nbeta - c2lmult2 + (betap*c2lmult23(-1)*eta*lambdac*thetap*(r(-1) - (eta(-1)*(r(-1) - rs))/(lambdap - v(-1)) + 1))/(lambdac(-1)*nbeta) + (betap*c2lmult22(-1)*eta*lambdac*thetap*v*(lambdap - v(-1))*(r(-1) - (eta(-1)*(r(-1) - rs))/(lambdap - v(-1)) + 1))/(eta(-1)*lambdac(-1)*nbeta*(lambdap - v)); 
c2lmult3 + c2lmult21*nlag*thetap*(r(-1) - (etalag*(r(-1) - rs))/(lambda(-1) - vlag) + 1); 
c2lmult17*(1/(c + cpref - clag*gammap)^2 + (betavar*gammap^2)/(c(+1) + cpref(+1) - c*gammap)^2) - c2lmult35 - c2lmult4(+1)*nbeta + 1/(c + cpref - clag*gammap) - (betavar(-1)*c2lmult17(-1)*gammap)/(nbeta*(c + cpref - c(-1)*gammap)^2); 
c2lmult4 - gammap/(c + cpref - clag*gammap) - (c2lmult17*gammap)/(c + cpref - clag*gammap)^2; 
c2lmult31 + (c2lmult28(-1)*y)/(nbeta*(rmon(-1) + 1)); 
c2lmult30 + c2lmult28*y; 
(c2lmult20*n*(bt - 1))/(lambda - v) - c2lmult22*((betap*eta(+1)*lambdac(+1)*thetap*v(+1)*(r - rs(+1))*(bt(+1) - 1))/(eta*lambdac*(lambdap - v(+1))) + (betap*eta(+1)*lambdac(+1)*thetap*v(+1)*(lambdap - v)*(bt(+1) - 1)*(r - (eta*(r - rs(+1)))/(lambdap - v) + 1))/(eta^2*lambdac*(lambdap - v(+1)))) - c2lmult23*((betap*eta(+1)*lambdac(+1)*thetap*(r - rs(+1))*(bt(+1) - 1))/(lambdac*(lambdap - v)) - 1) - c2lmult38/(lambdap - v) - c2lmult5(+1)*nbeta + (betap*c2lmult23(-1)*lambdac*thetap*(bt - 1)*(r(-1) - (eta(-1)*(r(-1) - rs))/(lambdap - v(-1)) + 1))/(lambdac(-1)*nbeta) + (betap*c2lmult22(-1)*lambdac*thetap*v*(lambdap - v(-1))*(bt - 1)*(r(-1) - (eta(-1)*(r(-1) - rs))/(lambdap - v(-1)) + 1))/(eta(-1)*lambdac(-1)*nbeta*(lambdap - v)); 
c2lmult5 - (c2lmult21*nlag*thetap*(r(-1) - rs)*(btlag - 1))/(lambda(-1) - vlag); 
c2lmult36 - c2lmult35; 
c2lmult33*((psip*(ig/iglag - 1)^2)/2 + (ig*psip*(ig/iglag - 1))/iglag - 1) - c2lmult6(+1)*nbeta - c2lmult35 - c2lmult34*((ig*psip*q)/ig(-1)^2 + (2*psip*q*(ig/ig(-1) - 1))/ig(-1) + (betavar*ig(+1)^3*lambdac(+1)*psip*q(+1))/(ig^4*lambdac) + (2*betavar*ig(+1)^2*lambdac(+1)*psip*q(+1)*(ig(+1)/ig - 1))/(ig^3*lambdac)) + (c2lmult34(-1)*((betavar(-1)*ig^2*lambdac*psip*q)/(ig(-1)^3*lambdac(-1)) + (2*betavar(-1)*ig*lambdac*psip*q*(ig/ig(-1) - 1))/(ig(-1)^2*lambdac(-1))))/nbeta + c2lmult34(+1)*nbeta*((ig(+1)^2*psip*q(+1))/ig^3 + (2*ig(+1)*psip*q(+1)*(ig(+1)/ig - 1))/ig^2); 
c2lmult6 - (c2lmult33*ig^2*psip*(ig/iglag - 1))/iglag^2; 
c2lmult33 - c2lmult32; 
c2lmult31*((infl^2*phip)/(indexp*infl(-1) - infl_ss*(indexp - 1))^2 + (2*infl*phip*(infl/(indexp*infl(-1) - infl_ss*(indexp - 1)) - 1))/(indexp*infl(-1) - infl_ss*(indexp - 1))) - c2lmult7(+1)*nbeta - c2lmult1 - c2lmult30*((infl*phip)/(indexp*infl(-1) - infl_ss*(indexp - 1))^2 + (phip*(infl/(indexp*infl(-1) - infl_ss*(indexp - 1)) - 1))/(indexp*infl(-1) - infl_ss*(indexp - 1))) - c2lmult31(+1)*nbeta*((indexp*infl(+1)^3*phip)/(indexp*infl - infl_ss*(indexp - 1))^3 + (indexp*infl(+1)^2*phip*(infl(+1)/(indexp*infl - infl_ss*(indexp - 1)) - 1))/(indexp*infl - infl_ss*(indexp - 1))^2) + c2lmult30(+1)*nbeta*((indexp*infl(+1)^2*phip)/(indexp*infl - infl_ss*(indexp - 1))^3 + (indexp*infl(+1)*phip*(infl(+1)/(indexp*infl - infl_ss*(indexp - 1)) - 1))/(indexp*infl - infl_ss*(indexp - 1))^2) - (c2lmult29*phip*(infl/(indexp*infllag - infl_ss*(indexp - 1)) - 1))/(indexp*infllag - infl_ss*(indexp - 1)) - (c2lmult39(-1)*lambdac)/(infl^2*lambdac(-1)*nbeta); 
c2lmult7 + (c2lmult29*indexp*infl*phip*(infl/(indexp*infllag - infl_ss*(indexp - 1)) - 1))/(indexp*infllag - infl_ss*(indexp - 1))^2; 
c2lmult2; 
c2lmult24 + c2lmult32 - c2lmult8(+1)*nbeta; 
c2lmult8 + c2lmult32*(deltap - 1) - alphap*c2lmult25*klag^(alphap - 1)*l^(1 - alphap)*exp(z) + (alphap*c2lmult27*sigma*y)/(klag^2*q(-1)); 
c2lmult26 - c2lmult9(+1)*nbeta - chi0p*l^chip + c2lmult18*chip*chi0p*l^(chip - 1) + (c2lmult25*klag^alphap*exp(z)*(alphap - 1))/l^alphap; 
c2lmult38; 
c2lmult17 - c2lmult18*w + c2lmult22*((betap*lambdac(+1)*(r - rs(+1))*(thetap - 1))/lambdac^2 - (betap*eta(+1)*lambdac(+1)*thetap*v(+1)*(lambdap - v)*(bt(+1) - 1)*(r - (eta*(r - rs(+1)))/(lambdap - v) + 1))/(eta*lambdac^2*(lambdap - v(+1)))) - (c2lmult22(-1)*((betap*(r(-1) - rs)*(thetap - 1))/lambdac(-1) - (betap*eta*thetap*v*(lambdap - v(-1))*(bt - 1)*(r(-1) - (eta(-1)*(r(-1) - rs))/(lambdap - v(-1)) + 1))/(eta(-1)*lambdac(-1)*(lambdap - v))))/nbeta + c2lmult19(-1)/(lambdac(-1)*nbeta) - (c2lmult19*lambdac(+1))/lambdac^2 + c2lmult39(-1)/(infl*lambdac(-1)*nbeta) - (c2lmult39*lambdac(+1))/(infl(+1)*lambdac^2) - (betap*c2lmult23*eta(+1)*lambdac(+1)*thetap*(bt(+1) - 1)*(r - (eta*(r - rs(+1)))/(lambdap - v) + 1))/lambdac^2 + (betap*c2lmult23(-1)*eta*thetap*(bt - 1)*(r(-1) - (eta(-1)*(r(-1) - rs))/(lambdap - v(-1)) + 1))/(lambdac(-1)*nbeta) + (betavar(-1)*c2lmult34(-1)*ig^2*psip*q*(ig/ig(-1) - 1))/(ig(-1)^2*lambdac(-1)*nbeta) - (betavar*c2lmult34*ig(+1)^2*lambdac(+1)*psip*q(+1)*(ig(+1)/ig - 1))/(ig^2*lambdac^2); 
c2lmult9; 
c2lmult21 - c2lmult13(+1)*nbeta - c2lmult40/y + (c2lmult20*eta*(bt - 1))/(lambda - v); 
c2lmult40; 
c2lmult13 + c2lmult21*thetap*(btlag - 1)*(r(-1) - (etalag*(r(-1) - rs))/(lambda(-1) - vlag) + 1); 
c2lmult29 - c2lmult35*y; 
c2lmult20*s - c2lmult34*((psip*(ig/ig(-1) - 1)^2)/2 + (ig*psip*(ig/ig(-1) - 1))/ig(-1) - 1) - c2lmult11(+1)*nbeta - c2lmult27(+1)*nbeta*((q(+1)*(deltap - 1))/q^2 - (alphap*sigma(+1)*y(+1))/(klag(+1)*q^2)) + (c2lmult27*(deltap - 1))/q(-1) - baromegap*c2lmult21*slag + (betavar(-1)*c2lmult34(-1)*ig^2*lambdac*psip*(ig/ig(-1) - 1))/(ig(-1)^2*lambdac(-1)*nbeta); 
c2lmult11; 
c2lmult19/(betavar*(r + 1)^2) - c2lmult22*((betap*lambdac(+1)*(thetap - 1))/lambdac + (betap*eta(+1)*lambdac(+1)*thetap*v(+1)*(eta/(lambdap - v) - 1)*(lambdap - v)*(bt(+1) - 1))/(eta*lambdac*(lambdap - v(+1)))) - c2lmult12(+1)*nbeta - c2lmult21(+1)*nbeta*nlag(+1)*thetap*(etalag(+1)/(lambda - vlag(+1)) - 1)*(btlag(+1) - 1) - (betap*c2lmult23*eta(+1)*lambdac(+1)*thetap*(eta/(lambdap - v) - 1)*(bt(+1) - 1))/lambdac; 
c2lmult12 + c2lmult37; 
c2lmult39/(betavar*(rmon + 1)^2) - c2lmult10(+1)*nbeta - (c2lmult28*dphidlp(+1)*y(+1))/(rmon + 1)^2; 
c2lmult10; 
c2lmult27 - c2lmult37 + (c2lmult22(-1)*((betap*lambdac*(thetap - 1))/lambdac(-1) + (betap*eta*lambdac*thetap*v*(bt - 1))/(lambdac(-1)*(lambdap - v))))/nbeta + (c2lmult21*etalag*nlag*thetap*(btlag - 1))/(lambda(-1) - vlag) + (betap*c2lmult23(-1)*eta*eta(-1)*lambdac*thetap*(bt - 1))/(lambdac(-1)*nbeta*(lambdap - v(-1))); 
c2lmult20*q - c2lmult14(+1)*nbeta - c2lmult24; 
(c2lmult26*y*(alphap - 1))/w - (c2lmult28*y*(nup + 1))/nup - (alphap*c2lmult27*y)/(klag*q(-1)); 
c2lmult14 - baromegap*c2lmult21*q; 
c2lmult37 - mu_mpr*(2*spread - 2*spreadp); 
(c2lmult22(-1)*((betap*eta*lambdac*thetap*(lambdap - v(-1))*(bt - 1)*(r(-1) - (eta(-1)*(r(-1) - rs))/(lambdap - v(-1)) + 1))/(eta(-1)*lambdac(-1)*(lambdap - v)) + (betap*eta*lambdac*thetap*v*(lambdap - v(-1))*(bt - 1)*(r(-1) - (eta(-1)*(r(-1) - rs))/(lambdap - v(-1)) + 1))/(eta(-1)*lambdac(-1)*(lambdap - v)^2)))/nbeta - c2lmult22*((betap*eta(+1)*lambdac(+1)*thetap*v(+1)*(bt(+1) - 1)*(r - (eta*(r - rs(+1)))/(lambdap - v) + 1))/(eta*lambdac*(lambdap - v(+1))) + (betap*eta(+1)*lambdac(+1)*thetap*v(+1)*(r - rs(+1))*(bt(+1) - 1))/(lambdac*(lambdap - v)*(lambdap - v(+1))) - 1) - (c2lmult38*eta)/(lambdap - v)^2 - c2lmult15(+1)*nbeta + (c2lmult20*eta*n*(bt - 1))/(lambda - v)^2 - (betap*c2lmult23*eta*eta(+1)*lambdac(+1)*thetap*(r - rs(+1))*(bt(+1) - 1))/(lambdac*(lambdap - v)^2); 
c2lmult15 - (c2lmult21*etalag*nlag*thetap*(r(-1) - rs)*(btlag - 1))/(lambda(-1) - vlag)^2; 
- c2lmult18*lambdac - (c2lmult26*sigma*y*(alphap - 1))/w^2; 
c2lmult25 - c2lmult16(+1)*nbeta - c2lmult36*omegagyp + c2lmult28*(dphidp + (markup + taup + 1)/nup - (sigma*(nup + 1))/nup) - c2lmult35*(phi - 1) + (c2lmult40*n)/y^2 + (c2lmult28(-1)*dphidlp)/(nbeta*(rmon(-1) + 1)) + (c2lmult26*sigma*(alphap - 1))/w - (alphap*c2lmult27*sigma)/(klag*q(-1)); 
c2lmult16; 
 
// Household preferences 
Util_nobias = (log(c-gammap*clag+cpref)-chi0p*l^(chip+1)/(chip+1)); 
 
// Welfare of households 
Welf_nobias = Util_nobias + betap*Welf_nobias(1); 
 
 
 
///////////////////////// 
// Structural equations 
///////////////////////// 
 
// choice of optimal consumption 
lambdac = 1/(c-gammap*clag+cpref)-betavar*gammap/(c(1)-gammap*c+cpref(1)); 
 
// choice of optimal labor supply 
chi0p*l^chip = lambdac*w; 
 
// choice of optimal deposit holdings 
lambdac(1)/lambdac = 1/(betavar*(1+r)); 
 
// leverage constraint 
q*s = eta/(lambda-v)*n*(1-bt); 
 
// evolution of bank equity 
n = thetap *((rs-r(-1))*etalag/(lambda(-1)-vlag)+1+r(-1))*nlag*(1-btlag) + baromegap*q*slag; 
 
// marginal value of loans 
v = (1-thetap)*betap*lambdac(1)/lambdac*(rs(1)-r)+thetap*betap*lambdac(1)/lambdac*( (eta(1)/(lambdap-v(1))) / (eta/(lambdap-v))*((rs(1)-r)*eta/(lambdap-v)+1+r))*(1-bt(1))*v(1); 
 
// marginal value of equity 
eta = (1-thetap)+thetap*betap*lambdac(1)/lambdac*((rs(1)-r)*eta/(lambdap-v)+1+r)*(1-bt(1))*eta(1); 
 
// equity financing for capital (next period) 
k = s; 
 
// production function 
y = exp(z)*klag^alphap*l^(1-alphap); 
 
// choice of optimal labor input 
l = (1-alphap)*sigma*y/w; 
 
// zero profit condition 
1+rs = alphap*sigma*y/(q(-1)*klag)+(1-deltap)*q/q(-1); 
 
// first order condition with respect to prices 
0 = (-(1+taup+markup)/nup + sigma*(1 + nup)/nup)*y 
    - y*dphidp 
    - (1/(1+rmon))*y(1)*dphidlp(1); 
 
// price adjustment costs and its derivatives 
phi = (phip/2)*(infl/(indexp*infllag+(1-indexp)*infl_ss) - 1)^2; 
dphidp = phip*(infl/(indexp*infl(-1)+(1-indexp)*infl_ss) - 1)*infl/(indexp*infl(-1)+(1-indexp)*infl_ss); 
dphidlp = -phip*(infl/(indexp*infl(-1)+(1-indexp)*infl_ss) - 1)*infl^2/(indexp*infl(-1)+(1-indexp)*infl_ss); 
 
// evolution of physical capital 
k = in+(1-deltap)*klag; 
 
// investment adjustment costs 
in = (1-psip/2*(ig/iglag-1)^2)*ig; 
 
// price of capital from optimal investment choice 
q*(1-psip/2*(ig/ig(-1)-1)^2)-q*psip*(ig/ig(-1)-1)*ig/ig(-1)+betavar*lambdac(1)/lambdac*q(1)*psip*(ig(1)/ig-1)*ig(1)^2/ig^2 = 1; 
 
// aggregate resource constraint 
y = c+ig+gc+phi*y; 
 
// government spending 
gc = omegagyp*y; 
 
// loan spread 
spread = rs - rlag; 
 
// ratio of loans to equity (pre-bt shock) 
l2n = eta/(lambdap-v); 
 
// nominal interest rate 
lambdac(1)/lambdac/infl(1) = 1/(betavar*(1+rmon)); 
 
// net worth to output ratio 
n2y = n/y; 
 
// Utility, agent 1  
Util1 = (log(c-gammap*clag+cpref)-chi0p*l^(chip+1)/(chip+1))-mu_cb*(infl-infl_ss)^2; 
 
// Utility, agent 2 
Util2 = (log(c-gammap*clag+cpref)-chi0p*l^(chip+1)/(chip+1))-mu_mpr*(spread-spreadp)^2; 
 
 
///////////////////////// 
// exogenous variables 
///////////////////////// 
 
// shock process for lambda  
lambda - lambdap = rholambdap*(lambda(-1) - lambdap) + sigmalambdap*errlambda; 
 
// shock to beta 
betavar - betap = rhobetavarp*(betavar(-1)-betap)+sigmabetavarp*errbetavar; 
 
// consumption preference shock 
cpref = rhocprefp*cpref(-1) + sigmacprefp*errcpref; 
 
// shock to technology 
z = rhozp*z(-1)+sigmazp*errz; 
 
// markup shock 
markup = rhomarkup*markup(-1)+sigmamarkup*errmarkup; 
end; 
 
 
shocks; 
  var errz; stderr 1; 
end; 
//stoch_simul(order=2,nocorr,irf=0, pruning,periods=10000);  
 
 
stoch_simul(order=2,irf=0, nomoments,periods=0);  
